import java.awt.*;
import java.io.*;
import javabook.*;

public	class PersonListe	implements Serializable
{
		private	final	int	maxAntal = 50;
		private				Person	[]	personTab;
		private				int					antal;
		
		public	PersonListe	()
		{
				personTab = new Person[maxAntal];
				antal = 0;
		}
	
		public	void	indlaesListe	(int hentAntal)
		{
				// lokal MainWindow og InputBox		tillades her for simpel lsning
				MainWindow mainWindow = new MainWindow("PersonListe input");
				InputBox  inputBox    = new InputBox(mainWindow);
				mainWindow.show();

				String[] label = {"Name","Age","Gender"}; 
				MultiInputBox multiBox = new MultiInputBox(mainWindow,label);
				String[] answer;

				for (int i=0; i < hentAntal; i++)
				{
						answer  = multiBox.getInputs();

						String name		= answer[0];						
						int    age		= Convert.toInt(answer[1]);
						char   gender = answer[2].charAt(0);

// med "hjlpe" variabel (hndtag/reference)
						Person	person = new Person(name, age, gender);
						personTab[i] = person;

// alternativ 2
//						personTab[i] = new Person(name, age, gender);
			
// alternativ 3
//						personTab[i] = new Person();
//						personTab[i].setName  (name);						
//						personTab[i].setAge   (age);						
//						personTab[i].setGender(gender);

				}

				antal = hentAntal;
		}

		public	void	udskrivListe	()
		{
				for (int i=0; i < antal; i++)
				{
						Person	p	= personTab[i];
						System.out.println("nr "+i+ " navn: "+p.getName()+
															 " alder:"+ p.getAge()+
															 " kn:"+ p.getGender()	);
				}
		}
		private	String	setKorrektFileName	(String	fileName)
		{
				if ((fileName.length() == 0) || (fileName.indexOf('.') == 0))
						fileName = "data";
				else if	(fileName.indexOf('.') > 0)
						fileName = fileName.substring(0,fileName.indexOf('.'));
				fileName = fileName+".dat";
				return	(fileName);
		}

// Lsning med brug af try-catch til fejlhndtering
		public	void	saveListe2	()	throws IOException
		{
				// lokal MainWindow og InputBox
	      MainWindow mainWindow = new MainWindow("PersonListe input");
	      mainWindow.show();

  	    FileDialog  fileBox    = new FileDialog(mainWindow, "SaveListe", FileDialog.SAVE);
	      fileBox.show();
	      
	      String	fileName			=	fileBox.getFile();
	      String	directoryName	=	fileBox.getDirectory();
	      
				fileName = directoryName+setKorrektFileName(fileName);
					
				try
				{
						File	outFile	=	new	File(fileName);
						FileOutputStream	outFileStream	=	new	FileOutputStream(outFile);
						ObjectOutputStream	outObjectStream	=	new	ObjectOutputStream(outFileStream);
						
						outObjectStream.writeInt(antal);
						for (int i=0; i < antal; i++)
						{
								outObjectStream.writeObject(personTab[i]);
						}

						outObjectStream.close();

				}
				catch (FileNotFoundException	e)
				{
			      System.out.println("Filen "+fileName+" eksisterer ikke");
				}	
				catch (IOException	e)
				{
			      System.out.println("Generel I/O exception");
			      throw e;
				}	
				finally
				{
						// udfres selvom fejl	
				}	
		}

// Lsning med brug af try-catch til fejlhndtering
		public	void	loadListe2	()	throws IOException, ClassNotFoundException

		{
				// lokal MainWindow og InputBox
	      MainWindow mainWindow = new MainWindow("PersonListe input");
	      mainWindow.show();

  	    FileDialog  fileBox    = new FileDialog(mainWindow, "LoadListe", FileDialog.LOAD);
	      fileBox.show();
	      
	      String	fileName			=	fileBox.getFile();
	      String	directoryName	=	fileBox.getDirectory();
	      
				fileName = directoryName+setKorrektFileName(fileName);
					
				try
				{
						File	inFile	=	new	File(fileName);
						FileInputStream	inFileStream	=	new	FileInputStream(inFile);
						ObjectInputStream	inObjectStream	=	new	ObjectInputStream(inFileStream);
						
						antal = inObjectStream.readInt();
						for (int i=0; i < antal; i++)
						{
								personTab[i] = (Person)inObjectStream.readObject();
						}

						inObjectStream.close();

				}
				catch (FileNotFoundException	e)
				{
			      System.out.println("Filen "+fileName+" eksisterer ikke");
				}	
				catch (EOFException	e)
				{
			      System.out.println("Fejl: der kan ikke lses forbi slutning af filen");
				}	
				catch (IOException	e)
				{
			      System.out.println("Generel I/O exception");
			      throw e;
				}	
				finally
				{
						// udfres selvom fejl	
				}	
		}
	

}