import java.awt.*;
import java.io.*;
import javax.swing.JOptionPane;
/**
 * Klasse: Klasse med eksempel p samling af Person objekter i en personliste med tilhrende metoder
 * @version  Septemper 2003
 * @author   Bjrk Busch
**/

public  class PersonListe
{
    private final  int       maxAntal = 50;
    private        Person[]  personTab;
    private        int       antal;

    public    PersonListe    ()
    {
        personTab = new Person[maxAntal];
        antal = 0;
    }

    public    void    indlaesListe    (int hentAntal)
    {

        for (int i=0; i < hentAntal; i++)
        {
            String  name = JOptionPane.showInputDialog(null,"Person nr: "+0+" Name:");
            String  sage = JOptionPane.showInputDialog(null,"Person nr: "+0+" Age:");
            String  sgender = JOptionPane.showInputDialog(null,"Person nr: "+0+" Gender:");
            int    age        = Integer.parseInt(sage);
            char   gender = sgender.charAt(0);

// med "hjlpe" variabel (hndtag/reference)
            Person    person = new Person(name, age, gender);
            personTab[i] = person;
// alternativ 2
//          personTab[i] = new Person(name, age, gender);

// alternativ 3
//          personTab[i] = new Person();
//          personTab[i].setName  (name);
//          personTab[i].setAge   (age);
//          personTab[i].setGender(gender);
        }

        antal = hentAntal;
    }

    public    void    udskrivListe    ()
    {
        for (int i=0; i < antal; i++)
        {
            Person    p    = personTab[i];
            System.out.println("nr "+i+ " navn: "+p.getName()+
                                                 " alder:"+ p.getAge()+
                                                 " kn:"+ p.getGender()    );
        }
    }

    private    String    setKorrektFileName    (String    fileName)
    {
        if ((fileName.length() == 0) || (fileName.indexOf('.') == 0))
            fileName = "data";
        else if    (fileName.indexOf('.') > 0)
            fileName = fileName.substring(0,fileName.indexOf('.'));
        fileName = fileName+".dat";
        return    (fileName);
    }
    
// Lsning hvor hele array gemmes samlet
    public    void    saveListe3    ()    throws IOException
    {
        // lokal MainWindow og InputBox
        MainWindow mainWindow = new MainWindow("PersonListe input");
        mainWindow.show();
    
        FileDialog  fileBox    = new FileDialog(mainWindow, "2. SaveListe", FileDialog.SAVE);
        fileBox.show();
      
        String    fileName         =    fileBox.getFile();
        String    directoryName    =    fileBox.getDirectory();
      
        fileName = directoryName+setKorrektFileName(fileName);
            
        try
        {
            File                outFile         = new File(fileName);
            FileOutputStream    outFileStream   = new FileOutputStream(outFile);
            ObjectOutputStream  outObjectStream = new ObjectOutputStream(outFileStream);
            
            outObjectStream.writeObject(personTab);        // hele array

            outObjectStream.close();

        }
        catch (FileNotFoundException    e)
        {
            System.out.println("Filen "+fileName+" eksisterer ikke");
        }    
        catch (IOException    e)
        {
            System.out.println("Generel I/O exception");
            throw e;
        }    
        finally
        {
                // udfres selvom fejl    
        }
    }
    
    // Lsning hvor hele array indlses samlet (der oprettes nyt)
    public    void    loadListe3    ()    throws IOException, ClassNotFoundException
    
    {
        // lokal MainWindow og InputBox
        MainWindow mainWindow = new MainWindow("PersonListe input");
        mainWindow.show();
    
        FileDialog  fileBox    = new FileDialog(mainWindow, "2. LoadListe", FileDialog.LOAD);
        fileBox.show();
      
        String    fileName         =    fileBox.getFile();
        String    directoryName    =    fileBox.getDirectory();
      
        fileName = directoryName+setKorrektFileName(fileName);
            
        try
        {
            File               inFile         = new File(fileName);
            FileInputStream    inFileStream   = new FileInputStream(inFile);
            ObjectInputStream  inObjectStream = new ObjectInputStream(inFileStream);
            
            personTab = (Person[])inObjectStream.readObject();  // hele array
            inObjectStream.close();

            antal=0;
            while ((antal < personTab.length)&&(personTab[antal] != null))
                antal++;

        }
        catch (FileNotFoundException    e)
        {
            System.out.println("Filen "+fileName+" eksisterer ikke");
        }    
        catch (EOFException    e)
        {
            System.out.println("Fejl: der kan ikke lses forbi slutning af filen");
        }    
        catch (IOException    e)
        {
            System.out.println("Generel I/O exception");
            throw e;
        }    
        finally
        {
                // udfres selvom fejl    
        }
    }
}
